#include<stdio.h>
#include <pthread.h>

void* child_routine( void * param )
{
  int id = (int)param;
  printf( "Thread %i\n", id );
}

void main()
{
  pthread_t thread;
  pthread_attr_t attributes;
  pthread_attr_init( &attributes );
  pthread_attr_setdetachstate( &attributes, PTHREAD_CREATE_DETACHED );
  pthread_create( &thread, &attributes, child_routine, 0 );
  pthread_attr_destroy( &attributes );
}
