#include <stdlib.h>
#include <omp.h>

int main()
{
  double * array1, *array2;
  omp_set_nested( 1 );
  #pragma omp parallel sections shared( array1, array2 )
  {
    #pragma omp section
    {
      array1 = (double*)malloc( sizeof(double)*1024*1024 );
      #pragma omp parallel for shared(array1)
      for ( int i=0; i<1024*1024; i++ )
      {
        array1[i] = i;
      }
    }
    #pragma omp section
    {
      array2 = (double*)malloc( sizeof(double)*1024*512 );
      #pragma omp parallel for shared(array2)
      for ( int i=0; i<1024*512; i++ )
      {
        array2[i] = i;
      }
    }
  }
}
