#include <omp.h>
#include <stdio.h>

void main()
{
  double total = 0.0;
  double array[1000];
  omp_set_num_threads( 2 );
  #pragma omp parallel for reduction( +: total )
  for ( int i=0; i<1000; i++ )
  {
    total += array[i];
  }
  printf( "Total=%f\n", total );
  printf( "Threads=%i\n", omp_get_max_threads() );
}
