#include <stdio.h>
#include <pthread.h>

volatile int counter=0;

void *work( void* param )
{
  int i;
  for( i=0; i<1000000; i++ )
  {
     __sync_fetch_and_add( &counter, 1 );
  }
}

int main()
{
  int i;
  pthread_t threads[10];
  for( i=0; i<10; i++ )
  {
     pthread_create( &threads[i], 0, work, 0 );
  }
  work( 0 );
  for( i=0; i<10; i++ )
  {
     pthread_join( threads[i], 0 );
  }
  printf( "Counter=%i\n", counter );
}
