#include <stdio.h>
#include <pthread.h>
#include <stdlib.h>

volatile int volatile buffer[16];
volatile int addhere;
volatile int removehere;

void clearbuffer()
{
  addhere = 0;
  removehere = 0;
  for ( int i=0; i<16;i++ ) { buffer[i] = 0; }
}

int next( int current )
{
  return ( current + 1 ) & 15;
}

void addtobuffer( int value )
{
  while( buffer[ next(addhere) ] != 0 ) {}
  buffer[addhere] = value;
  addhere = next(addhere);
}

int removefrombuffer()
{
  int value;
  while( ( value = buffer[removehere] ) == 0 ) {}
  buffer[removehere] = 0;
  removehere = next(removehere);
  return value;
}

void * producer( void *param )
{
  for( int i=1; i<10000000; i++ )
  {
    addtobuffer( i );
  }
}

void * consumer ( void *param )
{
  while ( removefrombuffer() != 9999999 ) {}
}

int main()
{
  clearbuffer();
  pthread_t threads[2];
  pthread_create( &threads[0], 0, producer, 0 );
  pthread_create( &threads[1], 0, consumer, 0 );
  pthread_join( threads[1], 0 );
  pthread_join( threads[0], 0 );
}

