#include <unistd.h>
#include <stdio.h>
#include <sys/stat.h>
#include <fcntl.h>

int main()
{
  int status;
  mknod( "/tmp/pipefile", S_IFIFO|S_IRUSR|S_IWUSR, 0 );
  pid_t f = fork();
  if ( f == 0 )
  { /* Child process */
    int mypipe = open( "/tmp/pipefile", O_WRONLY );
    write( mypipe, "a", 1 );
    printf( "Child sent 'a'\n" );
    close( mypipe );
  }
  else
  {
    int mypipe = open( "/tmp/pipefile", O_RDONLY );
    char buffer[11];
    int len = read( mypipe, buffer, 10 );
    buffer[len] = 0;
    printf( "Parent received %s\n", buffer );
    close( mypipe );
  }
  unlink( "/tmp/pipefile" );
  return 0;
}
