#include <windows.h>
#include <process.h>
#include <stdio.h>

HANDLE semaphore;
int value;

void addToValue( int increment )
{
  WaitForSingleObject( semaphore, INFINITE );
  value+=increment;
  ReleaseSemaphore( semaphore, 1, 0 );
}

unsigned int __stdcall test( void * )
{
  for ( int counter=0; counter<100; counter++ )
  {
    addToValue( 2 );
  }
  return 0;
}

int _tmain( int argc, _TCHAR* argv[])
{
  HANDLE h1, h2;
  value = 0;
  semaphore = CreateSemaphore( 0, 1, 1, 0 );
  h1 = (HANDLE)_beginthreadex( 0, 0, &test, (void*)0, 0, 0);
  h2 = (HANDLE)_beginthreadex( 0, 0, &test, (void*)0, 0, 0);
  WaitForSingleObject( h1, INFINITE );
  WaitForSingleObject( h2, INFINITE );
  CloseHandle( h1 );
  CloseHandle( h2 );
  CloseHandle( semaphore );
  printf( "Value = %i\n", value );
  getchar();
  return 0;
}
