#include <stdio.h>
#include <omp.h>
#include <stdlib.h>

void main()
{
  int *ready = calloc( sizeof(int), 2 );

  #pragma omp parallel num_threads( 2 )
  {
     printf( "Thread %i is ready\n", omp_get_thread_num() );
     ready[ omp_get_thread_num() ] = 1;
     int neighbour = ( omp_get_thread_num()+1 ) % omp_get_num_threads();

     while( ready[neighbour] == 0 )
     {
       #pragma omp flush
     }

     printf( "Thread %i is done\n", omp_get_thread_num() );
  }
  free( ready );
}
