#include <stdlib.h>
#include <pthread.h>

int nthreads;

void *work( void * param )
{
  int count = 1000000 / nthreads;
  for( int i=0; i<count; i++ )
  {
    void *mem = malloc(1024);
    free( mem );
  }
}

int main( int argc, char*argv[] )
{
  pthread_t thread[50];
  nthreads = 8;
  if ( argc > 1 ) { nthreads = atoi( argv[1] ); }
  for( int i=0; i<nthreads; i++ )
  {
    pthread_create( &thread[i], 0, work, 0 );
  }
  for( int i=0; i<nthreads; i++ )
  {
    pthread_join( thread[i], 0 );
  }
  return 0;
}
